unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, _GClass, AbGradient, AbCBitBt, AbGearDial, _AbProc,
  ColorGrd, AbBevel, Buttons;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    AbGradient1: TAbGradient;
    AbGradient2: TAbGradient;
    AbGradient3: TAbGradient;
    AbGearDial1: TAbGearDial;
    AbGearDial2: TAbGearDial;
    ColorDialog1: TColorDialog;
    GroupBox2: TGroupBox;
    ColorFromBevel: TAbBevel;
    ColorToBevel: TAbBevel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox3: TGroupBox;
    AbColBitBtn1: TAbColBitBtn;
    AbColBitBtn2: TAbColBitBtn;
    AbColBitBtn3: TAbColBitBtn;
    AbColBitBtn4: TAbColBitBtn;
    AbColBitBtn5: TAbColBitBtn;
    AbColBitBtn6: TAbColBitBtn;
    AbColBitBtn7: TAbColBitBtn;
    AbColBitBtn8: TAbColBitBtn;
    AbColBitBtn9: TAbColBitBtn;
    AbColBitBtn10: TAbColBitBtn;
    AbColBitBtn11: TAbColBitBtn;
    AbColBitBtn12: TAbColBitBtn;
    AbColBitBtn13: TAbColBitBtn;
    AbColBitBtn14: TAbColBitBtn;
    Label1: TLabel;
    SwapColorBtn: TSpeedButton;
    procedure AbGradientClick(Sender: TObject);
    procedure ColorFromBevelClick(Sender: TObject);
    procedure ColorToBevelClick(Sender: TObject);
    procedure SetColors;
    procedure SwapColorBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SetColors;
var
  n : Integer;
begin
  AbGradient1.GradSettings.ColorFrom := ColorFromBevel.BevelOuter.Color;
  AbGradient2.GradSettings.ColorFrom := ColorFromBevel.BevelOuter.Color;
  AbGradient3.GradSettings.ColorFrom := ColorFromBevel.BevelOuter.Color;
  AbGearDial1.BevelGearDial.SurfaceGrad.ColorFrom := ColorFromBevel.BevelOuter.Color;
  AbGearDial2.BevelGearDial.SurfaceGrad.ColorFrom := ColorFromBevel.BevelOuter.Color;
  AbGradient1.GradSettings.ColorTo := ColorToBevel.BevelOuter.Color;
  AbGradient2.GradSettings.ColorTo := ColorToBevel.BevelOuter.Color;
  AbGradient3.GradSettings.ColorTo := ColorToBevel.BevelOuter.Color;
  AbGearDial1.BevelGearDial.SurfaceGrad.ColorTo := ColorToBevel.BevelOuter.Color;
  AbGearDial2.BevelGearDial.SurfaceGrad.ColorTo := ColorToBevel.BevelOuter.Color;
  // Set ColorFrom/To of all style-buttons
  for n := 0 to ComponentCount -1 do begin
     if  Components[n] is TAbColBitBtn then
       with Components[n] as TAbColBitBtn do begin
         GradBtnFace.ColorFrom := ColorFromBevel.BevelOuter.Color;
         GradBtnFace.ColorTo := ColorToBevel.BevelOuter.Color;
       end;
  end;

end;

procedure TForm1.AbGradientClick(Sender: TObject);
Var
  GrdSettings : TAbGradSettings;
begin
  // set preview to selected gradient-Style
  if (Sender As TAbColBitBtn).Checked then begin
    GrdSettings := (Sender As TAbColBitBtn).GradBtnFace;
    AbGradient1.GradSettings.Assign(GrdSettings);
    AbGradient2.GradSettings.Assign(GrdSettings);
    AbGradient3.GradSettings.Assign(GrdSettings);
    AbGearDial1.BevelGearDial.SurfaceGrad.Assign(GrdSettings);
    AbGearDial2.BevelGearDial.SurfaceGrad.Assign(GrdSettings);
    Label1.caption := (Sender As TControl).Hint;
  end;
end;

procedure TForm1.ColorFromBevelClick(Sender: TObject);
begin
  // change gradient-ColorFrom
  ColorDialog1.Color := ColorFromBevel.BevelOuter.Color;
  if ColorDialog1.Execute then begin
    ColorFromBevel.BevelOuter.Color := ColorDialog1.Color;
    SetColors;
  end;
end;

procedure TForm1.ColorToBevelClick(Sender: TObject);
begin
  // Change gradient-ColorTo
  ColorDialog1.Color := ColorToBevel.BevelOuter.Color;
  if ColorDialog1.Execute then begin
    ColorToBevel.BevelOuter.Color := ColorDialog1.Color;
    SetColors;
  end;
end;

procedure TForm1.SwapColorBtnClick(Sender: TObject);
var
  col : TColor;
begin
  // swap gradient colors
  col := ColorToBevel.BevelOuter.Color;
  ColorToBevel.BevelOuter.Color := ColorFromBevel.BevelOuter.Color;
  ColorFromBevel.BevelOuter.Color := col;
  SetColors;
end;

end.
