unit ScaleSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  _GClass, AbVMeter, StdCtrls, AbCBitBt, Buttons, AbNumEdit;

type
  TClassTAbScaleSettings_Form = class(TForm)
    AbVMeter1: TAbVMeter;
    ColorBitBtn: TAbColBitBtn;
    Label1: TLabel;
    PointerColorBitBtn: TAbColBitBtn;
    Label2: TLabel;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    Ok_BitBtn: TBitBtn;
    Cancel_BitBtn: TBitBtn;
    Font_Btn: TSpeedButton;
    PosLeftTop_CheckBox: TCheckBox;
    DrawLine_CheckBox: TCheckBox;
    StepsSpin: TAbNumSpin;
    SubStepsSpin: TAbNumSpin;
    Label3: TLabel;
    Label4: TLabel;
    ValueFormat_Edit: TEdit;
    ValueFormatLog_Edit: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Ok_BitBtnClick(Sender: TObject);
    procedure DrawLine_CheckBoxClick(Sender: TObject);
    procedure PosLeftTop_CheckBoxClick(Sender: TObject);
    procedure StepsSpinValueChanged(Sender: TObject);
    procedure SubStepsSpinValueChanged(Sender: TObject);
    procedure ValueFormat_EditChange(Sender: TObject);
    procedure ValueFormatLog_EditChange(Sender: TObject);
    procedure ColorBitBtnClick(Sender: TObject);
    procedure PointerColorBitBtnClick(Sender: TObject);
    procedure Font_BtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure GetSettings;
  public
    { Public-Deklarationen }
  end;

var
  ClassTAbScaleSettings_Form: TClassTAbScaleSettings_Form;
  SclSettings : TScaleSettings;
  SclSettingsOld : TScaleSettings;

implementation

{$R *.DFM}

procedure TClassTAbScaleSettings_Form.GetSettings;
begin
  with SclSettings do begin
    PointerColorBitBtn.ColorOff := PointerColor;
    PointerColorBitBtn.ColorOn := PointerColor;
    ColorBitBtn.ColorOff := SclSettings.Color;
    ColorBitBtn.ColorOn := SclSettings.Color;
    DrawLine_CheckBox.Checked := DrawLine;
    PosLeftTop_CheckBox.Checked := PosLeftTop;
    StepsSpin.Value := Steps;
    SubStepsSpin.Value := SubSteps;
    ValueFormat_Edit.Text := ValueFormat;
    ValueFormatLog_Edit.Text := ValueFormatLog;
    Label7.Visible := LogScale;
    if Logscale then Label6.Font.Color := clBlack else
                     Label6.Font.Color := clBtnShadow;
  end;
end;

procedure TClassTAbScaleSettings_Form.FormCreate(Sender: TObject);
begin
  SclSettings := AbVMeter1.ScaleSettings;

  SclSettingsOld := TScaleSettings.Create;
  SclSettingsOld.Assign(AbVMeter1.ScaleSettings);
  GetSettings;
end;

procedure TClassTAbScaleSettings_Form.FormDestroy(Sender: TObject);
begin
  SclSettingsOld.Free;
end;

procedure TClassTAbScaleSettings_Form.Ok_BitBtnClick(Sender: TObject);
begin
  close;
end;

procedure TClassTAbScaleSettings_Form.DrawLine_CheckBoxClick(
  Sender: TObject);
begin
  SclSettings.DrawLine := DrawLine_CheckBox.Checked;
end;

procedure TClassTAbScaleSettings_Form.PosLeftTop_CheckBoxClick(
  Sender: TObject);
begin
  SclSettings.PosLeftTop := PosLeftTop_CheckBox.Checked;
end;

procedure TClassTAbScaleSettings_Form.StepsSpinValueChanged(
  Sender: TObject);
begin
  SclSettings.Steps := StepsSpin.ValueAsInt;
end;

procedure TClassTAbScaleSettings_Form.SubStepsSpinValueChanged(
  Sender: TObject);
begin
  SclSettings.SubSteps := SubStepsSpin.ValueAsInt;
end;

procedure TClassTAbScaleSettings_Form.ValueFormat_EditChange(
  Sender: TObject);
begin
  SclSettings.ValueFormat := ValueFormat_Edit.Text;
end;

procedure TClassTAbScaleSettings_Form.ValueFormatLog_EditChange(
  Sender: TObject);
begin
  SclSettings.ValueFormatLog := ValueFormatLog_Edit.Text;
end;

procedure TClassTAbScaleSettings_Form.ColorBitBtnClick(Sender: TObject);
begin
  ColorDialog1.Color := SclSettings.Color;
  if ColorDialog1.Execute then SclSettings.Color := ColorDialog1.Color;
  GetSettings;
end;

procedure TClassTAbScaleSettings_Form.PointerColorBitBtnClick(
  Sender: TObject);
begin
  ColorDialog1.Color := SclSettings.PointerColor;
  if ColorDialog1.Execute then SclSettings.PointerColor := ColorDialog1.Color;
  GetSettings;
end;

procedure TClassTAbScaleSettings_Form.Font_BtnClick(Sender: TObject);
begin
  FontDialog1.Font.Assign(SclSettings.Font);
  if FontDialog1.Execute then begin
    SclSettings.Font.Assign(FontDialog1.Font);
  end;
end;

end.
