unit SectorSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, _GClass, AbCBitBt, AbVMeter, AbNumEdit, AbHMeter;

type
  TClassSectorSettingsForm = class(TForm)
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Sector1ColorBtn: TAbColBitBtn;
    Sector2ColorBtn: TAbColBitBtn;
    Sector3ColorBtn: TAbColBitBtn;
    Sector3FromEdit: TAbNumEdit;
    Sector3ToEdit: TAbNumEdit;
    Sector2FromEdit: TAbNumEdit;
    Sector2ToEdit: TAbNumEdit;
    Sector1FromEdit: TAbNumEdit;
    Sector1ToEdit: TAbNumEdit;
    ColorDialog1: TColorDialog;
    AbHMeter1: TAbHMeter;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox1: TGroupBox;
    PPT_RadioButton: TRadioButton;
    Value_RadioButton: TRadioButton;
    procedure OkBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Sector3FromEditValueChanged(Sender: TObject);
    procedure Sector3ToEditValueChanged(Sender: TObject);
    procedure Sector2FromEditValueChanged(Sender: TObject);
    procedure Sector2ToEditValueChanged(Sender: TObject);
    procedure Sector1FromEditValueChanged(Sender: TObject);
    procedure Sector1ToEditValueChanged(Sender: TObject);
    procedure Sector3ColorBtnClick(Sender: TObject);
    procedure Sector2ColorBtnClick(Sender: TObject);
    procedure Sector1ColorBtnClick(Sender: TObject);
    procedure PPT_RadioButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure GetSettings;
  public
    { Public-Deklarationen }
  end;

var
  ClassSectorSettingsForm: TClassSectorSettingsForm;
  SectSettings : TSectorSettings;
  SectorSettingsOld : TSectorSettings;

implementation

{$R *.DFM}

procedure TClassSectorSettingsForm.GetSettings;
begin
  with SectSettings do begin
    Sector1ColorBtn.ColorOff := Sector1Color;
    Sector1ColorBtn.ColorOn := Sector1Color;
    Sector2ColorBtn.ColorOff := Sector2Color;
    Sector2ColorBtn.ColorOn := Sector2Color;
    Sector3ColorBtn.ColorOff := Sector3Color;
    Sector3ColorBtn.ColorOn := Sector3Color;

    if PPT_RadioButton.Checked then begin
      Sector1FromEdit.Value := Sector1From;
      Sector1ToEdit.Value := Sector1To;
      Sector2FromEdit.Value := Sector2From;
      Sector2ToEdit.Value := Sector2To;
      Sector3FromEdit.Value := Sector3From;
      Sector3ToEdit.Value := Sector3To;
    end else begin
      Sector1FromEdit.Value := AbHMeter1.SignalSettings.GetValue(Sector1From);
      Sector1ToEdit.Value := AbHMeter1.SignalSettings.GetValue(Sector1To);
      Sector2FromEdit.Value := AbHMeter1.SignalSettings.GetValue(Sector2From);
      Sector2ToEdit.Value := AbHMeter1.SignalSettings.GetValue(Sector2To);
      Sector3FromEdit.Value := AbHMeter1.SignalSettings.GetValue(Sector3From);
      Sector3ToEdit.Value := AbHMeter1.SignalSettings.GetValue(Sector3To);
    end;
  end;
end;

procedure TClassSectorSettingsForm.OkBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TClassSectorSettingsForm.FormCreate(Sender: TObject);
begin
  SectSettings      := AbHMeter1.SectorSettings;
  SectorSettingsOld := TSectorSettings.Create;
  SectorSettingsOld.Assign(SectSettings);
  GetSettings;
end;

procedure TClassSectorSettingsForm.FormDestroy(Sender: TObject);
begin
  SectorSettingsOld.Free;
end;

procedure TClassSectorSettingsForm.Sector3FromEditValueChanged(
  Sender: TObject);
begin
  if PPT_RadioButton.Checked then
    SectSettings.Sector3From := Sector3FromEdit.ValueAsInt
  else
    SectSettings.Sector3From := AbHMeter1.SignalSettings.GetPPT(Sector3FromEdit.ValueAsSingle);

  GetSettings;
end;

procedure TClassSectorSettingsForm.Sector3ToEditValueChanged(
  Sender: TObject);
begin
  if PPT_RadioButton.Checked then
    SectSettings.Sector3To := Sector3ToEdit.ValueAsInt
  else
    SectSettings.Sector3To := AbHMeter1.SignalSettings.GetPPT(Sector3ToEdit.ValueAsSingle);
  GetSettings;
end;

procedure TClassSectorSettingsForm.Sector2FromEditValueChanged(
  Sender: TObject);
begin
  if PPT_RadioButton.Checked then
    SectSettings.Sector2From := Sector2FromEdit.ValueAsInt
  else
    SectSettings.Sector2From := AbHMeter1.SignalSettings.GetPPT(Sector2FromEdit.ValueAsSingle);
  GetSettings;
end;

procedure TClassSectorSettingsForm.Sector2ToEditValueChanged(
  Sender: TObject);
begin
  if PPT_RadioButton.Checked then
    SectSettings.Sector2To := Sector2ToEdit.ValueAsInt
  else
    SectSettings.Sector2To := AbHMeter1.SignalSettings.GetPPT(Sector2ToEdit.ValueAsSingle);
  GetSettings;
end;

procedure TClassSectorSettingsForm.Sector1FromEditValueChanged(
  Sender: TObject);
begin
  if PPT_RadioButton.Checked then
    SectSettings.Sector1From := Sector1FromEdit.ValueAsInt
  else
    SectSettings.Sector1From := AbHMeter1.SignalSettings.GetPPT(Sector1FromEdit.ValueAsSingle);
  GetSettings;
end;

procedure TClassSectorSettingsForm.Sector1ToEditValueChanged(
  Sender: TObject);
begin
  if PPT_RadioButton.Checked then
    SectSettings.Sector1To := Sector1ToEdit.ValueAsInt
  else
    SectSettings.Sector1To := AbHMeter1.SignalSettings.GetPPT(Sector1ToEdit.ValueAsSingle);
  GetSettings;
end;

procedure TClassSectorSettingsForm.Sector3ColorBtnClick(Sender: TObject);
begin
  ColorDialog1.Color := SectSettings.Sector3Color;
  if ColorDialog1.Execute then begin
    SectSettings.Sector3Color := ColorDialog1.Color;
    GetSettings;
  end;
end;

procedure TClassSectorSettingsForm.Sector2ColorBtnClick(Sender: TObject);
begin
  ColorDialog1.Color := SectSettings.Sector2Color;
  if ColorDialog1.Execute then begin
    SectSettings.Sector2Color := ColorDialog1.Color;
    GetSettings;
  end;
end;

procedure TClassSectorSettingsForm.Sector1ColorBtnClick(Sender: TObject);
begin
  ColorDialog1.Color := SectSettings.Sector1Color;
  if ColorDialog1.Execute then begin
    SectSettings.Sector1Color := ColorDialog1.Color;
    GetSettings;
  end;
end;

procedure TClassSectorSettingsForm.PPT_RadioButtonClick(Sender: TObject);
begin
  GetSettings;
end;

end.
