unit Unit_CircularProgressbar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, AbNumEdit, AbProgressBar, ExtCtrls,
  ComCtrls, _GClass, AbVInd;

type
  TForm_CircularProgressBar = class(TForm)
    AbCircularProgressBar1: TAbCircularProgressBar;
    gbBarSettings: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    cob_CapStart1: TComboBox;
    cob_CapEnd1: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    Spin_Width: TAbNumSpin;
    Label5: TLabel;
    Image1: TImage;
    tb_AngleRotation: TTrackBar;
    tb_AngleStart: TTrackBar;
    tb_Value: TTrackBar;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    gb_BarBkSettings: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    cob_CapEnd2: TComboBox;
    cob_CapStart2: TComboBox;
    spin_Width2: TAbNumSpin;
    Col_1: TColorBox;
    col_2: TColorBox;
    Label14: TLabel;
    gb_InnerCircle: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Spin_Diameter: TAbNumSpin;
    col_3: TColorBox;
    Check_Visible: TCheckBox;
    AbCircularProgressBar2: TAbCircularProgressBar;
    AbCircularProgressBar4: TAbCircularProgressBar;
    Spin_Alpha_Rel1: TAbNumSpin;
    Spin_Alpha_Rel2: TAbNumSpin;
    Spin_Alpha_Rel3: TAbNumSpin;
    AbCircularProgressBar3: TAbCircularProgressBar;
    AbCircularProgressBar5: TAbCircularProgressBar;
    AbCircularProgressBar6: TAbCircularProgressBar;
    ChB_ShowZero: TCheckBox;
    procedure Spin_Alpha_Rel1ValueChanged(Sender: TObject);
    procedure cob_CapStart1Change(Sender: TObject);
    procedure cob_CapEnd1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure tb_AngleRotationChange(Sender: TObject);
    procedure tb_AngleStartChange(Sender: TObject);
    procedure tb_ValueChange(Sender: TObject);
    procedure Spin_WidthValueChanged(Sender: TObject);
    procedure Spin_Alpha_Rel2ValueChanged(Sender: TObject);
    procedure cob_CapStart2Change(Sender: TObject);
    procedure cob_CapEnd2Change(Sender: TObject);
    procedure spin_Width2ValueChanged(Sender: TObject);
    procedure col_2Change(Sender: TObject);
    procedure Col_1Change(Sender: TObject);
    procedure Spin_Alpha_Rel3ValueChanged(Sender: TObject);
    procedure col_3Change(Sender: TObject);
    procedure Spin_DiameterValueChanged(Sender: TObject);
    procedure Check_VisibleClick(Sender: TObject);
    procedure ChB_ShowZeroClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form_CircularProgressBar: TForm_CircularProgressBar;

implementation

{$R *.dfm}

procedure TForm_CircularProgressBar.Spin_Alpha_Rel1ValueChanged(
  Sender: TObject);
begin
  AbCircularProgressBar1.BarSettings.Alpha_Rel := Spin_Alpha_Rel1.Value;
end;

procedure TForm_CircularProgressBar.cob_CapStart1Change(Sender: TObject);
begin
  AbCircularProgressBar1.BarSettings.CapStart := TAbLineCap(cob_CapStart1.ItemIndex);
end;

procedure TForm_CircularProgressBar.cob_CapEnd1Change(Sender: TObject);
begin
  AbCircularProgressBar1.BarSettings.CapEnd := TAbLineCap(cob_CapEnd1.ItemIndex);
end;

procedure TForm_CircularProgressBar.Button1Click(Sender: TObject);
begin
  AbCircularProgressBar1.Invalidate;
end;

procedure TForm_CircularProgressBar.tb_AngleRotationChange(Sender: TObject);
begin
  AbCircularProgressBar1.AngleRotation := tb_AngleRotation.Position/10;
end;

procedure TForm_CircularProgressBar.tb_AngleStartChange(Sender: TObject);
begin
  AbCircularProgressBar1.AngleStart := tb_AngleStart.Position/10;
end;

procedure TForm_CircularProgressBar.tb_ValueChange(Sender: TObject);
begin
  AbCircularProgressBar1.Value := tb_Value.Position/10;
  AbCircularProgressBar2.Value := AbCircularProgressBar1.Value / 2;
  AbCircularProgressBar3.Value := AbCircularProgressBar1.Value / 4;
  AbCircularProgressBar4.Value := AbCircularProgressBar1.Value / 10;
  AbCircularProgressBar5.Value := AbCircularProgressBar1.Value / 4;
  AbCircularProgressBar6.Value := AbCircularProgressBar1.Value / 2;
end;

procedure TForm_CircularProgressBar.Spin_WidthValueChanged(
  Sender: TObject);
begin
  AbCircularProgressBar1.BarSettings.Width_Rel := Spin_Width.Value;
end;

procedure TForm_CircularProgressBar.Spin_Alpha_Rel2ValueChanged(
  Sender: TObject);
begin
  AbCircularProgressBar1.BarBkSettings.Alpha_Rel := Spin_Alpha_Rel2.Value;
end;

procedure TForm_CircularProgressBar.cob_CapStart2Change(Sender: TObject);
begin
  AbCircularProgressBar1.BarBkSettings.CapStart := TAbLineCap(cob_CapStart2.ItemIndex);
end;

procedure TForm_CircularProgressBar.cob_CapEnd2Change(Sender: TObject);
begin
  AbCircularProgressBar1.BarBkSettings.CapEnd := TAbLineCap(cob_CapEnd2.ItemIndex);
end;

procedure TForm_CircularProgressBar.spin_Width2ValueChanged(
  Sender: TObject);
begin
  AbCircularProgressBar1.BarBkSettings.Width_Rel := Spin_Width2.Value;
end;

procedure TForm_CircularProgressBar.col_2Change(Sender: TObject);
begin
  AbCircularProgressBar1.BarBkSettings.Color := col_2.Selected;
end;

procedure TForm_CircularProgressBar.Col_1Change(Sender: TObject);
begin
  AbCircularProgressBar1.BarSettings.Color := col_1.Selected;
end;

procedure TForm_CircularProgressBar.Spin_Alpha_Rel3ValueChanged(
  Sender: TObject);
begin
  AbCircularProgressBar1.InnerCircle.Alpha_Rel := Spin_Alpha_Rel3.Value;
end;

procedure TForm_CircularProgressBar.col_3Change(Sender: TObject);
begin
  AbCircularProgressBar1.InnerCircle.Color := col_3.Selected;
end;

procedure TForm_CircularProgressBar.Spin_DiameterValueChanged(
  Sender: TObject);
begin
  AbCircularProgressBar1.InnerCircle.Diameter_Rel := Spin_Diameter.Value;
end;

procedure TForm_CircularProgressBar.Check_VisibleClick(Sender: TObject);
begin
  AbCircularProgressBar1.InnerCircle.Visible := Check_Visible.Checked;
end;

procedure TForm_CircularProgressBar.ChB_ShowZeroClick(Sender: TObject);
begin
  AbCircularProgressBar1.BarSettings.ShowZero := ChB_ShowZero.Checked;
end;

end.
