unit Unit1;

{===============================================================================
 Trend Demo to show
      - How to add manually records (AddValue)
      - Set the time of a new record
      - how to use PaintRecords
      - how MoveX is used to scroll the x-axis

 Remark: may don't shows the correct values in <= V2.01
===============================================================================}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AbTrend, StdCtrls, _GClass;

type
  TForm1 = class(TForm)
    AbTrend1: TAbTrend;
    FirstRecLabel: TLabel;
    CreateButton: TButton;
    ShowLastButton: TButton;
    ShowFirstButton: TButton;
    MoveBackButton: TButton;
    MoveFwdButton: TButton;
    ClearButton: TButton;
    LastRecLabel: TLabel;
    Memo1: TMemo;
    Label3: TLabel;
    procedure CreateButtonClick(Sender: TObject);
    procedure ShowLastButtonClick(Sender: TObject);
    procedure ShowFirstButtonClick(Sender: TObject);
    procedure MoveBackButtonClick(Sender: TObject);
    procedure MoveFwdButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure GetRecInfo;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GetRecInfo;
begin
  { routine display's the record-No of the FirstDisplayedRec + LastDisplayedRec
    Remark: may don't shows the correct values in <= V2.01 }

  FirstRecLabel.caption := 'FirstDisplayedRecord = ' + IntToStr(AbTrend1.RecordInfo.FirstDisplayedRec);
  LastRecLabel.caption := 'LastDisplayedRecord = ' + IntToStr(AbTrend1.RecordInfo.LastDisplayedRec);
end;

procedure TForm1.CreateButtonClick(Sender: TObject);
var
  n, i : Integer;
begin

{ routine clears the Trend.RecordList and add's 100.000 new items with user-defined
  date, at last the records 0..MaxVisRecords are painted
  NOTE: StartRecording must be "false"}

  with AbTrend1 do begin
    StartRecording := False;   // StartRecording must be "false"

    ClearRecords;

    for n := 1 to 100000 do begin   // create 100.000 records
                // max. no of records = 2.147.483.647  (High(integer))
                // ... to much for a normal PC, this are ~80 GByte Memory

      if i >= 1000 then i := 0;
      inc(i);

      AddValue(i*0.1,25+i*0.05,0,0,0,0,0,0);   // add record and fill with value
                                               // note: the time of this record = "now"

      ARecord^.Time := now + n*0.001;          // set the time for this record
    end;

    PaintRecords(0, High(Integer));            // will show the first records
    GetRecInfo;
  end;
end;

procedure TForm1.ShowLastButtonClick(Sender: TObject);
begin
  AbTrend1.PaintRecords( AbTrend1.RecordList.Count - AbTrend1.MaxVisRecords,
                         AbTrend1.RecordList.Count);   // will show the last records
  GetRecInfo;
end;

procedure TForm1.ShowFirstButtonClick(Sender: TObject);
begin
  AbTrend1.PaintRecords(0, High(Integer));            // will show the first records
  GetRecInfo;
end;

procedure TForm1.MoveBackButtonClick(Sender: TObject);
begin
  AbTrend1.MoveX(-300);                  // move display 300 records to the left
  GetRecInfo;
end;

procedure TForm1.MoveFwdButtonClick(Sender: TObject);
begin
  AbTrend1.MoveX(300);                   // move display 300 records to the right
  GetRecInfo;
end;

procedure TForm1.ClearButtonClick(Sender: TObject);
begin
    AbTrend1.ClearRecords;              // clear record-list
    GetRecInfo;
end;

end.
